'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

var _ajax = require('yylib-utils/ajax');

var _ajax2 = _interopRequireDefault(_ajax);

var _jsCookie = require('js-cookie');

var _jsCookie2 = _interopRequireDefault(_jsCookie);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * ncc附件管理组件
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author xg
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var Dragger = _antd.Upload.Dragger;

var NccAttachMgr = function (_React$Component) {
    _inherits(NccAttachMgr, _React$Component);

    function NccAttachMgr(props) {
        _classCallCheck(this, NccAttachMgr);

        var _this = _possibleConstructorReturn(this, (NccAttachMgr.__proto__ || Object.getPrototypeOf(NccAttachMgr)).call(this, props));

        _this.loadFiles = function () {
            var _this$state = _this.state,
                appCode = _this$state.appCode,
                billId = _this$state.billId;
            var _this$props = _this.props,
                serverUrl = _this$props.serverUrl,
                queryUrl = _this$props.queryUrl;

            if (appCode && billId) {
                var params = {
                    busiParamJson: JSON.stringify({
                        billId: '' + (appCode + '/' + billId),
                        fullPath: '' + (appCode + '/' + billId)
                    }),
                    sysParamJson: { appcode: appCode, pagecs: _jsCookie2.default.get("cookiets") }
                };
                _this.startLoading();
                _ajax2.default.postJSONWithCookies(serverUrl + queryUrl, params, function (result) {
                    if (result && result.success) {
                        var data = result.data || [];
                        data = data.filter(function (file) {
                            var levels = file.fullPath.split("/");
                            return levels.length === 3;
                        });
                        _this.setState({ files: data });
                    } else {
                        _antd.message.error("查询附件列表失败");
                    }
                }, function (error) {
                    _antd.message.error("查询附件列表失败");
                }, function () {
                    _this.stopLoading();
                });
            }
        };

        _this.startLoading = function () {
            _this.setState({ spinning: true });
        };

        _this.stopLoading = function () {
            _this.setState({ spinning: false });
        };

        _this.beforeUpload = function (file) {
            var retFlag = true;
            var _this$props2 = _this.props,
                accept = _this$props2.accept,
                beforeUpload = _this$props2.beforeUpload,
                serverUrl = _this$props2.serverUrl,
                uploadUrl = _this$props2.uploadUrl;
            // 1.校验附件服务基准地址和上传附件的服务地址

            if (!serverUrl || !uploadUrl) {
                _antd.message.error("附件服务地址未配置,无法上传");
                return false;
            }
            // 2.校验文件大小
            if (file.size === 0) {
                _antd.message.error("不允许上传空文件");
                return false;
            }
            // 3.校验文件格式
            if (accept) {
                var accpetSuffix = accept.split(",");
                var fileName = file.name;
                var suffix = fileName.substr(fileName.lastIndexOf("."), fileName.length);
                if (accpetSuffix.indexOf(suffix) === -1) {
                    _antd.message.error("只允许上传" + accept + "格式的文件");
                    return false;
                }
            }
            // 4.回调外部属性
            if (beforeUpload && typeof beforeUpload === "function") {
                retFlag = beforeUpload(file) || false;
            }
            _this.startLoading();
            return retFlag;
        };

        _this.getUploadParams = function () {
            var _this$state2 = _this.state,
                appCode = _this$state2.appCode,
                billId = _this$state2.billId;

            return {
                billId: '' + (appCode + '/' + billId),
                fullPath: '' + (appCode + '/' + billId),
                sys_appcode: '' + appCode
            };
        };

        _this.onChange = function (_ref) {
            var file = _ref.file,
                fileList = _ref.fileList;

            if (file.status === "done") {
                if (file.response.success) {
                    _antd.message.success("上传成功");
                    var files = _this.state.files;

                    _this.setState({ files: files.concat(file.response.data) });
                } else {
                    _antd.message.error(file.response.error && file.response.error.message ? file.response.error.message : "上传失败");
                    // fileList = fileList.filter((item) => { // 过滤掉失败的数据
                    //     return !!item.response.success;
                    // });
                    // this.setState({files: fileList});
                }
                _this.stopLoading();
            } else if (file.status === "error") {
                // 上传失败
                _antd.message.error("上传失败: 后端服务异常");
                _this.stopLoading();
            }
        };

        _this.onDownloadFile = function (record, e) {
            e.stopPropagation();
            var _this$props3 = _this.props,
                serverUrl = _this$props3.serverUrl,
                downloadUrl = _this$props3.downloadUrl;

            var requestUrl = serverUrl + downloadUrl;
            // 通过内嵌iframe窗口实现下载
            var downloadFrame = document.createElement('iframe');
            downloadFrame.id = "down-file-iframe";
            downloadFrame.style.width = "0";
            downloadFrame.style.height = "0";
            downloadFrame.style.display = "none";
            // 通过form实现post请求
            var downloadForm = document.createElement('form');
            downloadForm.id = "down-file-form";
            downloadForm.target = "down-file-iframe";
            downloadForm.method = "post";
            downloadForm.action = requestUrl;
            downloadForm.style.visibility = "hidden";
            // 通过隐藏的input标签传递参数
            var nameInput = document.createElement('input');
            nameInput.type = 'hidden';
            nameInput.name = "name";
            nameInput.value = record.name;
            var pkDocInput = document.createElement('input');
            pkDocInput.type = 'hidden';
            pkDocInput.name = "pk_doc";
            pkDocInput.value = record.pk_doc;
            downloadForm.append(nameInput);
            downloadForm.append(pkDocInput);
            downloadFrame.append(downloadForm);
            document.body.appendChild(downloadFrame);
            document.getElementById("down-file-form").submit();
            document.body.removeChild(downloadFrame);
        };

        _this.onDeleteFile = function (record) {
            var _ref2 = record || {},
                billId = _ref2.billId,
                fullPath = _ref2.fullPath,
                pk_doc = _ref2.pk_doc;

            var _this$props4 = _this.props,
                serverUrl = _this$props4.serverUrl,
                deleteUrl = _this$props4.deleteUrl;
            var _this$state3 = _this.state,
                appCode = _this$state3.appCode,
                files = _this$state3.files;

            var params = {
                busiParamJson: JSON.stringify({
                    billId: billId,
                    fullPath: fullPath,
                    pk_doc: pk_doc
                }),
                sysParamJson: { appcode: appCode, pagecs: _jsCookie2.default.get("cookiets") }
            };
            _this.startLoading();
            _ajax2.default.postJSONWithCookies(serverUrl + deleteUrl, params, function (result) {
                if (result && result.success) {
                    _this.setState({
                        files: files.filter(function (file) {
                            // 从文件列表中移除删除的文件
                            return file.pk_doc !== pk_doc;
                        })
                    });
                    _antd.message.success("删除成功");
                } else {
                    _antd.message.error("删除附件失败");
                }
            }, function (error) {
                _antd.message.error("删除附件失败");
            }, function () {
                _this.stopLoading();
            });
        };

        _this.onCancel = function (e) {
            e.stopPropagation();
            if (_this.props.onCancel && typeof _this.props.onCancel === "function") {
                _this.props.onCancel();
            }
        };

        _this.state = {
            spinning: false,
            showModal: _this.props.showModal,
            allowUpload: _this.props.allowUpload,
            allowDelete: _this.props.allowDelete,
            files: _this.props.defaultFileList,
            serverUrl: _this.props.serverUrl,
            appCode: _this.props.appCode,
            billId: _this.props.billId
        };
        return _this;
    }

    _createClass(NccAttachMgr, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.loadFiles();
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (nextProps.showModal !== undefined && nextProps.showModal !== this.props.showModal) {
                this.setState({ showModal: nextProps.showModal });
            }
            if (nextProps.appCode && nextProps.appCode !== this.props.appCode || nextProps.billId && nextProps.billId !== this.props.billId) {
                this.setState({ appCode: nextProps.appCode, billId: nextProps.billId }, this.loadFiles);
            }
        }

        // 加载附件列表


        // 上传前的回调


        // 获取上传的参数


        // 上传文件


        // 下载附件


        // 删除附件


        // 关闭附件管理窗口

    }, {
        key: 'getColumns',


        // 表格显示列配置
        value: function getColumns() {
            var _this2 = this;

            var allowDelete = this.state.allowDelete;

            return [{
                title: '文件名',
                dataIndex: 'name',
                key: 'name',
                width: 150
            }, {
                title: '文件大小',
                dataIndex: 'fileSize',
                key: 'fileSize',
                width: 100,
                render: function render(text) {
                    if (!isNaN(text)) {
                        text = parseInt(text);
                    }
                    return _react2.default.createElement(
                        'span',
                        null,
                        (text / 1000).toFixed(2),
                        'KB'
                    );
                }
            }, {
                title: '操作',
                key: 'operation',
                width: 100,
                render: function render(text, record) {
                    return _react2.default.createElement(
                        'div',
                        null,
                        _react2.default.createElement(
                            'span',
                            null,
                            _react2.default.createElement(
                                'a',
                                { style: { marginRight: 3 }, onClick: _this2.onDownloadFile.bind(_this2, record) },
                                '\u4E0B\u8F7D'
                            )
                        ),
                        _react2.default.createElement('span', { className: 'ant-divider' }),
                        _react2.default.createElement(
                            _antd.Popconfirm,
                            { title: '\u786E\u5B9A\u8981\u5220\u9664\u8FD9\u4E2A\u6587\u4EF6\u5417\uFF1F',
                                onConfirm: _this2.onDeleteFile.bind(_this2, record) },
                            _react2.default.createElement(
                                'a',
                                { style: { marginLeft: 3 }, disabled: !allowDelete, onClick: function onClick(e) {
                                        e.stopPropagation();
                                    } },
                                '\u5220\u9664'
                            )
                        )
                    );
                }
            }];
        }
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props,
                serverUrl = _props.serverUrl,
                uploadUrl = _props.uploadUrl;

            var action = serverUrl + uploadUrl;
            var _state = this.state,
                files = _state.files,
                spinning = _state.spinning;

            return this.state.showModal ? _react2.default.createElement(
                _antd.Modal,
                { title: '\u9644\u4EF6\u7BA1\u7406', visible: this.state.showModal,
                    footer: _react2.default.createElement(
                        _antd.Button,
                        { style: { background: '#FFF' }, onClick: this.onCancel },
                        '\u5173\u95ED'
                    ),
                    maskClosable: false,
                    onCancel: this.onCancel, style: { minWidth: 700 } },
                _react2.default.createElement(
                    _antd.Spin,
                    { spinning: spinning },
                    _react2.default.createElement(
                        'div',
                        { style: { height: 100 } },
                        _react2.default.createElement(
                            Dragger,
                            _extends({}, this.props, { beforeUpload: this.beforeUpload, onChange: this.onChange,
                                data: this.getUploadParams,
                                withCredentials: true, action: action }),
                            _react2.default.createElement(_antd.Icon, { type: 'inbox', style: { color: '#f0b138', fontSize: 40 } }),
                            _react2.default.createElement(
                                'p',
                                { className: 'ant-upload-text' },
                                _react2.default.createElement(
                                    'a',
                                    null,
                                    '\u70B9\u6B64\u4E0A\u4F20'
                                ),
                                ', \u6216\u5C06\u6587\u4EF6\u62D6\u62FD\u5230\u6B64\u533A\u57DF\u4E0A\u4F20'
                            ),
                            this.props.accept ? _react2.default.createElement(
                                'p',
                                { className: 'ant-upload-hint' },
                                '\u6700\u5927\u652F\u630110M\uFF0C\u5141\u8BB8\u4E0A\u4F20 ',
                                this.props.accept,
                                ' \u683C\u5F0F\u6587\u4EF6'
                            ) : _react2.default.createElement(
                                'p',
                                { className: 'ant-upload-hint' },
                                '\u6700\u5927\u652F\u630110M'
                            )
                        )
                    ),
                    _react2.default.createElement(
                        'div',
                        { style: { marginTop: 10 } },
                        _react2.default.createElement(_antd.Table, { size: 'small', columns: this.getColumns(), dataSource: files, pagination: false })
                    )
                )
            ) : null;
        }
    }]);

    return NccAttachMgr;
}(_react2.default.Component);

// 默认属性


exports.default = NccAttachMgr;
NccAttachMgr.defaultProps = {
    showModal: false, // 是否显示弹出层
    allowUpload: true, // 是否允许上传附件
    allowDelete: true, // 是否允许删除附件
    beforeUpload: function beforeUpload() {
        return true;
    }, // 上传文件前的回调,返回true继续上传,返回false则终止上传动作
    onCancel: function onCancel() {}, // 取消
    accept: '', // 接受上传的文件类型
    defaultFileList: [], // 默认上传的文件列表
    serverUrl: '', // 附件服务基准地址
    queryUrl: '/nccloud/platform/attachment/query.do', // 查询附件的服务地址
    uploadUrl: '/nccloud/platform/attachment/upload.do', // 上传文件的服务地址
    deleteUrl: '/nccloud/platform/attachment/delete.do', // 删除附件的服务地址
    downloadUrl: '/nccloud/platform/attachment/download.do', // 下载附件的服务地址
    showUploadList: false // 是否展示uploadList
};